function [wl, ravg] = averagespectra(r, T, plotscale, mdata)
dirin = mdata.dirin;
XMIN = 350.00; XMAX = 900.00;
YMIN =   0.00; YMAX =  30.00;
% Cidx = 42;  % value at wavelength ~ 350 nm
Bidx =  42;   % value at wavelength ~ 350 nm
Cidx = 107;   % value at wavelength ~ 450 nm
Didx = 385;   % value at wavelength ~ 900 nm 
Eidx = 107;   % ~ 450 nm
Fidx = 234;   % ~ 650 nm
gray = [0.7 0.7 0.7];
r1idx = find(T==1); r2idx = find(T==2); r3idx = find(T==3);
r1avg = mean(r(:,3,r1idx), 3); r2avg = mean(r(:,3,r2idx), 3); r3avg = mean(r(:,3,r3idx), 3);
ravg = [r1avg r2avg r3avg];
figure('units','normalized','outerposition',[0 0 1 1]); hold on;
wl = r(:,1,1);
plot(wl, r1avg, 'g', 'LineWidth', 4);
plot(wl, r2avg, 'b', 'LineWidth', 4);
plot(wl, r3avg, 'r', 'LineWidth', 4);
for scnt = 1:length(r(1,1,:))
    if     (T(scnt) == 1) 
        MarkerColor = 'g'; % Water
    elseif (T(scnt) == 2)
        MarkerColor = 'b'; % Sky
    elseif (T(scnt) == 3)
        MarkerColor = 'r'; % Reference
    else
        MarkerColor = 'k';
    end
    if (MarkerColor == 'k')
       plot(r(:,1,scnt),r(:,3,scnt), 'Color', gray, 'LineWidth', 2);
    else
        plot(r(:,1,scnt),r(:,3,scnt), MarkerColor);
    end
end
if     (plotscale == 0)
    ymax = YMAX;
elseif (plotscale == 1)
    ymax = max(max(r(:,3,r1idx)));
elseif (plotscale == 2)
    ymax = max(max(r(:,3,r2idx)));
elseif (plotscale == 3)
    ymax = max(max(r(:,3,r3idx)));
end
axis([XMIN,XMAX,YMIN,ymax]);
xlabel('Wavelength (nm)'); ylabel('Radiance (uW/cm^2/sr/nm)');
title('All Spectra (Bold Average)');
text(810, ymax*29/YMAX, 'Reference', 'Color', 'r', 'FontSize', 30);
text(810, ymax*27/YMAX, 'Sky',       'Color', 'b', 'FontSize', 30);
text(810, ymax*25/YMAX, 'Water',     'Color', 'g', 'FontSize', 30);
text(810, ymax*23/YMAX, 'Unused',    'Color', '[0.5 0.5 0.5]', 'FontSize', 30);
set(gca, 'FontSize', 20);
hold off;
screencapture(gcf,[],[dirin,'f_spe_2.png']); 
end
